# coding: utf-8

"""
    HCX API

    The HCX REST API. Please see https://api.ncloud-docs.com/docs/ai-naver-clovastudio-summary for more details.

    The version of the OpenAPI document: 24.1.5
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501

import warnings
from pydantic import validate_call, Field, StrictFloat, StrictStr, StrictInt
from typing import Any, Dict, List, Optional, Tuple, Union
from typing_extensions import Annotated

from pydantic import Field, StrictStr, field_validator
from typing_extensions import Annotated
from pyhcx.models.create_embedding_request import CreateEmbeddingRequest
from pyhcx.models.create_embedding_response import CreateEmbeddingResponse

from pyhcx.api_client import ApiClient, RequestSerialized
from pyhcx.api_response import ApiResponse
from pyhcx.rest import RESTResponseType


class EmbeddingsApi:
    """NOTE: This class is auto generated by OpenAPI Generator
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    def __init__(self, api_client=None) -> None:
        if api_client is None:
            api_client = ApiClient.get_default()
        self.api_client = api_client


    @validate_call
    def create_embedding(
        self,
        app_name: Annotated[StrictStr, Field(description="app Name")],
        model_name: Annotated[StrictStr, Field(description="model Name")],
        app_id: Annotated[StrictStr, Field(description="Application ID")],
        x_ncp_clovastudio_request_id: Annotated[StrictStr, Field(description="request id")],
        create_embedding_request: CreateEmbeddingRequest,
        _request_timeout: Union[
            None,
            Annotated[StrictFloat, Field(gt=0)],
            Tuple[
                Annotated[StrictFloat, Field(gt=0)],
                Annotated[StrictFloat, Field(gt=0)]
            ]
        ] = None,
        _request_auth: Optional[Dict[StrictStr, Any]] = None,
        _content_type: Optional[StrictStr] = None,
        _headers: Optional[Dict[StrictStr, Any]] = None,
        _host_index: Annotated[StrictInt, Field(ge=0, le=1)] = 0,
    ) -> CreateEmbeddingResponse:
        """create_embedding


        :param app_name: app Name (required)
        :type app_name: str
        :param model_name: model Name (required)
        :type model_name: str
        :param app_id: Application ID (required)
        :type app_id: str
        :param x_ncp_clovastudio_request_id: request id (required)
        :type x_ncp_clovastudio_request_id: str
        :param create_embedding_request: (required)
        :type create_embedding_request: CreateEmbeddingRequest
        :param _request_timeout: timeout setting for this request. If one
                                 number provided, it will be total request
                                 timeout. It can also be a pair (tuple) of
                                 (connection, read) timeouts.
        :type _request_timeout: int, tuple(int, int), optional
        :param _request_auth: set to override the auth_settings for an a single
                              request; this effectively ignores the
                              authentication in the spec for a single request.
        :type _request_auth: dict, optional
        :param _content_type: force content-type for the request.
        :type _content_type: str, Optional
        :param _headers: set to override the headers for a single
                         request; this effectively ignores the headers
                         in the spec for a single request.
        :type _headers: dict, optional
        :param _host_index: set to override the host_index for a single
                            request; this effectively ignores the host_index
                            in the spec for a single request.
        :type _host_index: int, optional
        :return: Returns the result object.
        """ # noqa: E501

        _param = self._create_embedding_serialize(
            app_name=app_name,
            model_name=model_name,
            app_id=app_id,
            x_ncp_clovastudio_request_id=x_ncp_clovastudio_request_id,
            create_embedding_request=create_embedding_request,
            _request_auth=_request_auth,
            _content_type=_content_type,
            _headers=_headers,
            _host_index=_host_index
        )

        _response_types_map: Dict[str, Optional[str]] = {
            '200': "CreateEmbeddingResponse",
        }
        response_data = self.api_client.call_api(
            *_param,
            _request_timeout=_request_timeout
        )
        response_data.read()
        return self.api_client.response_deserialize(
            response_data=response_data,
            response_types_map=_response_types_map,
        ).data


    @validate_call
    def create_embedding_with_http_info(
        self,
        app_name: Annotated[StrictStr, Field(description="app Name")],
        model_name: Annotated[StrictStr, Field(description="model Name")],
        app_id: Annotated[StrictStr, Field(description="Application ID")],
        x_ncp_clovastudio_request_id: Annotated[StrictStr, Field(description="request id")],
        create_embedding_request: CreateEmbeddingRequest,
        _request_timeout: Union[
            None,
            Annotated[StrictFloat, Field(gt=0)],
            Tuple[
                Annotated[StrictFloat, Field(gt=0)],
                Annotated[StrictFloat, Field(gt=0)]
            ]
        ] = None,
        _request_auth: Optional[Dict[StrictStr, Any]] = None,
        _content_type: Optional[StrictStr] = None,
        _headers: Optional[Dict[StrictStr, Any]] = None,
        _host_index: Annotated[StrictInt, Field(ge=0, le=1)] = 0,
    ) -> ApiResponse[CreateEmbeddingResponse]:
        """create_embedding


        :param app_name: app Name (required)
        :type app_name: str
        :param model_name: model Name (required)
        :type model_name: str
        :param app_id: Application ID (required)
        :type app_id: str
        :param x_ncp_clovastudio_request_id: request id (required)
        :type x_ncp_clovastudio_request_id: str
        :param create_embedding_request: (required)
        :type create_embedding_request: CreateEmbeddingRequest
        :param _request_timeout: timeout setting for this request. If one
                                 number provided, it will be total request
                                 timeout. It can also be a pair (tuple) of
                                 (connection, read) timeouts.
        :type _request_timeout: int, tuple(int, int), optional
        :param _request_auth: set to override the auth_settings for an a single
                              request; this effectively ignores the
                              authentication in the spec for a single request.
        :type _request_auth: dict, optional
        :param _content_type: force content-type for the request.
        :type _content_type: str, Optional
        :param _headers: set to override the headers for a single
                         request; this effectively ignores the headers
                         in the spec for a single request.
        :type _headers: dict, optional
        :param _host_index: set to override the host_index for a single
                            request; this effectively ignores the host_index
                            in the spec for a single request.
        :type _host_index: int, optional
        :return: Returns the result object.
        """ # noqa: E501

        _param = self._create_embedding_serialize(
            app_name=app_name,
            model_name=model_name,
            app_id=app_id,
            x_ncp_clovastudio_request_id=x_ncp_clovastudio_request_id,
            create_embedding_request=create_embedding_request,
            _request_auth=_request_auth,
            _content_type=_content_type,
            _headers=_headers,
            _host_index=_host_index
        )

        _response_types_map: Dict[str, Optional[str]] = {
            '200': "CreateEmbeddingResponse",
        }
        response_data = self.api_client.call_api(
            *_param,
            _request_timeout=_request_timeout
        )
        response_data.read()
        return self.api_client.response_deserialize(
            response_data=response_data,
            response_types_map=_response_types_map,
        )


    @validate_call
    def create_embedding_without_preload_content(
        self,
        app_name: Annotated[StrictStr, Field(description="app Name")],
        model_name: Annotated[StrictStr, Field(description="model Name")],
        app_id: Annotated[StrictStr, Field(description="Application ID")],
        x_ncp_clovastudio_request_id: Annotated[StrictStr, Field(description="request id")],
        create_embedding_request: CreateEmbeddingRequest,
        _request_timeout: Union[
            None,
            Annotated[StrictFloat, Field(gt=0)],
            Tuple[
                Annotated[StrictFloat, Field(gt=0)],
                Annotated[StrictFloat, Field(gt=0)]
            ]
        ] = None,
        _request_auth: Optional[Dict[StrictStr, Any]] = None,
        _content_type: Optional[StrictStr] = None,
        _headers: Optional[Dict[StrictStr, Any]] = None,
        _host_index: Annotated[StrictInt, Field(ge=0, le=1)] = 0,
    ) -> RESTResponseType:
        """create_embedding


        :param app_name: app Name (required)
        :type app_name: str
        :param model_name: model Name (required)
        :type model_name: str
        :param app_id: Application ID (required)
        :type app_id: str
        :param x_ncp_clovastudio_request_id: request id (required)
        :type x_ncp_clovastudio_request_id: str
        :param create_embedding_request: (required)
        :type create_embedding_request: CreateEmbeddingRequest
        :param _request_timeout: timeout setting for this request. If one
                                 number provided, it will be total request
                                 timeout. It can also be a pair (tuple) of
                                 (connection, read) timeouts.
        :type _request_timeout: int, tuple(int, int), optional
        :param _request_auth: set to override the auth_settings for an a single
                              request; this effectively ignores the
                              authentication in the spec for a single request.
        :type _request_auth: dict, optional
        :param _content_type: force content-type for the request.
        :type _content_type: str, Optional
        :param _headers: set to override the headers for a single
                         request; this effectively ignores the headers
                         in the spec for a single request.
        :type _headers: dict, optional
        :param _host_index: set to override the host_index for a single
                            request; this effectively ignores the host_index
                            in the spec for a single request.
        :type _host_index: int, optional
        :return: Returns the result object.
        """ # noqa: E501

        _param = self._create_embedding_serialize(
            app_name=app_name,
            model_name=model_name,
            app_id=app_id,
            x_ncp_clovastudio_request_id=x_ncp_clovastudio_request_id,
            create_embedding_request=create_embedding_request,
            _request_auth=_request_auth,
            _content_type=_content_type,
            _headers=_headers,
            _host_index=_host_index
        )

        _response_types_map: Dict[str, Optional[str]] = {
            '200': "CreateEmbeddingResponse",
        }
        response_data = self.api_client.call_api(
            *_param,
            _request_timeout=_request_timeout
        )
        return response_data.response


    def _create_embedding_serialize(
        self,
        app_name,
        model_name,
        app_id,
        x_ncp_clovastudio_request_id,
        create_embedding_request,
        _request_auth,
        _content_type,
        _headers,
        _host_index,
    ) -> RequestSerialized:

        _hosts = [
            'https://clovastudio.apigw.ntruss.com'
        ]
        _host = _hosts[_host_index]

        _collection_formats: Dict[str, str] = {
        }

        _path_params: Dict[str, str] = {}
        _query_params: List[Tuple[str, str]] = []
        _header_params: Dict[str, Optional[str]] = _headers or {}
        _form_params: List[Tuple[str, str]] = []
        _files: Dict[str, Union[str, bytes]] = {}
        _body_params: Optional[bytes] = None

        # process the path parameters
        if app_name is not None:
            _path_params['appName'] = app_name
        if model_name is not None:
            _path_params['modelName'] = model_name
        if app_id is not None:
            _path_params['appId'] = app_id
        # process the query parameters
        # process the header parameters
        if x_ncp_clovastudio_request_id is not None:
            _header_params['X-NCP-CLOVASTUDIO-REQUEST-ID'] = x_ncp_clovastudio_request_id
        # process the form parameters
        # process the body parameter
        if create_embedding_request is not None:
            _body_params = create_embedding_request


        # set the HTTP header `Accept`
        _header_params['Accept'] = self.api_client.select_header_accept(
            [
                'application/json'
            ]
        )

        # set the HTTP header `Content-Type`
        if _content_type:
            _header_params['Content-Type'] = _content_type
        else:
            _default_content_type = (
                self.api_client.select_header_content_type(
                    [
                        'application/json'
                    ]
                )
            )
            if _default_content_type is not None:
                _header_params['Content-Type'] = _default_content_type

        # authentication setting
        _auth_settings: List[str] = [
            'ApigwApiKey', 
            'ClovastudioApiKey'
        ]

        return self.api_client.param_serialize(
            method='POST',
            resource_path='/{appName}/v1/api-tools/embedding/{modelName}/{appId}',
            path_params=_path_params,
            query_params=_query_params,
            header_params=_header_params,
            body=_body_params,
            post_params=_form_params,
            files=_files,
            auth_settings=_auth_settings,
            collection_formats=_collection_formats,
            _host=_host,
            _request_auth=_request_auth
        )


