# coding: utf-8

"""
    HCX API

    The HCX REST API. Please see https://api.ncloud-docs.com/docs/ai-naver-clovastudio-summary for more details.

    The version of the OpenAPI document: 24.1.5
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictInt
from typing import Any, ClassVar, Dict, List, Optional
from pyhcx.models.get_training_task_list_result_content_inner import GetTrainingTaskListResultContentInner
from typing import Optional, Set
from typing_extensions import Self

class GetTrainingTaskListResult(BaseModel):
    """
    GetTrainingTaskListResult
    """ # noqa: E501
    total_pages: Optional[StrictInt] = Field(default=None, description="Total number of pages", alias="totalPages")
    total_elements: Optional[StrictInt] = Field(default=None, description="Total number of elements", alias="totalElements")
    size: Optional[StrictInt] = Field(default=None, description="Number of elements per page")
    number: Optional[StrictInt] = Field(default=None, description="Current page number")
    content: Optional[List[GetTrainingTaskListResultContentInner]] = None
    __properties: ClassVar[List[str]] = ["totalPages", "totalElements", "size", "number", "content"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of GetTrainingTaskListResult from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of each item in content (list)
        _items = []
        if self.content:
            for _item in self.content:
                if _item:
                    _items.append(_item.to_dict())
            _dict['content'] = _items
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of GetTrainingTaskListResult from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "totalPages": obj.get("totalPages"),
            "totalElements": obj.get("totalElements"),
            "size": obj.get("size"),
            "number": obj.get("number"),
            "content": [GetTrainingTaskListResultContentInner.from_dict(_item) for _item in obj["content"]] if obj.get("content") is not None else None
        })
        return _obj


